<script lang="ts" setup>
import { computed } from "@vue/reactivity";
import { ref, onMounted, onUpdated } from "vue";

import Prism from "prismjs";

Prism.manual = true;

const props = defineProps(["language", "text", "scroll"]);
const languageClass = computed(() => `language-${props.language ?? "javascript"}`);

const codeBlock = ref(null);
const preBlock = ref(null);

onMounted(() => {
  Prism.highlightAllUnder(codeBlock.value as any);

  if (props.scroll)
    (preBlock.value as any).scrollTop = (preBlock.value as any).scrollHeight;
});

onUpdated(() => {
  Prism.highlightAllUnder(codeBlock.value as any);

  if (props.scroll)
    (preBlock.value as any).scrollTop = (preBlock.value as any).scrollHeight;
});
</script>

<template>
  <div ref="codeBlock">
    <pre ref="preBlock"><code :class="languageClass">{{ text }}</code></pre>
  </div>
</template>
